﻿using Infragistics.Win.UltraWinDataSource;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ScrollToActiveRow
{
    public partial class Form1 : Form
    {

        private List<SampleData> _sampleData = new List<SampleData>();
        private Int16 _activeId = -1;
        //private int scrollPos = -1;

        //private UltraGridRow SelectedRow { get; set; } = null;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            sampleData();

            button1.Enabled = true;
            button2.Enabled = false;
        }



        private void sampleData()
        {
            //random generated junk from mockaroo.com
            #region
            string sampleData = @"1,Kathy,Long,klong0@jalbum.net,Female,205.33.228.28,
                                    2,Brian,Garza,bgarza1@nhs.uk,Male,191.12.123.20,
                                    3,John,Lawrence,jlawrence2@weather.com,Male,252.122.171.188,
                                    4,Pamela,Thomas,pthomas3@alibaba.com,Female,144.81.90.12,
                                    5,Melissa,Robinson,mrobinson4@paginegialle.it,Female,104.153.76.72,
                                    11,Kevin,Wright,kwrighta@loc.gov,Male,205.209.72.55,
                                    12,Kevin,Martinez,kmartinezb@dailymotion.com,Male,136.82.244.147,
                                    13,James,Anderson,jandersonc@mysql.com,Male,71.199.124.24,
                                    14,Mildred,Wilson,mwilsond@devhub.com,Female,58.218.43.195,
                                    15,Brian,Hawkins,bhawkinse@mail.ru,Male,109.224.150.198,
                                    16,Paula,Martinez,pmartinezf@issuu.com,Female,232.33.224.36,
                                    17,Henry,Stephens,hstephensg@army.mil,Male,18.69.15.222,
                                    18,David,Boyd,dboydh@csmonitor.com,Male,206.85.89.22,
                                    19,Keith,Olson,kolsoni@examiner.com,Male,22.137.46.144,
                                    20,Janet,Gray,jgrayj@ning.com,Female,206.228.208.107".Trim();
            #endregion

            string [] values = sampleData.Split(',');

            for (int index = 0; index < values.Count(); index += 6)
            {
                var data = values.Skip(index).Take(6).Select(x => x.ToString().Trim()).ToArray();
                _sampleData.Add(new SampleData()
                {
                    ID = Convert.ToInt16(data[0]),
                    FirstName = data[1].ToString(),
                    LastName = data[2].ToString(),
                    Email = data[3].ToString(),
                    Gender = data[4].ToString(),
                    IPAddress = data[5].ToString()
                });
            }

            _sampleData = _sampleData.OrderBy(o => o.ID).ToList();

            ultraDataSource1.Rows.SetCount(_sampleData.Count);
            ultraDataSource1.ResetCachedValues();

            ultraGrid1.ActiveRow = ultraGrid1.Rows[0];
            ultraGrid1.ActiveRow.Selected = true;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            button1.Enabled = false;
            //random generated junk from mockaroo.com
            #region
            string sampleData = @"6,Thomas,Hunter,thunter5@ucoz.com,Male,124.126.178.0,
                                    7,Aaron,Robertson,arobertson6@squarespace.com,Male,206.206.106.42,
                                    8,Judith,Price,jprice7@edublogs.org,Female,215.33.252.254,
                                    9,Howard,Ortiz,hortiz8@go.com,Male,122.12.248.126,
                                    10,Douglas,Snyder,dsnyder9@amazonaws.com,Male,28.22.144.247".Trim();
            #endregion

            string[] values = sampleData.Split(',');

            UltraGridRow prevRow = this.ultraGrid1.Rows.OfType<UltraGridRow>()
                .ToList()
                .Find(r => r.Cells[0].Text.Equals(_activeId.ToString(), StringComparison.CurrentCultureIgnoreCase));

     

            for (int index = 0; index < values.Count(); index += 6)
            {
                var data = values.Skip(index).Take(6).Select(x => x.ToString().Trim()).ToArray();
                _sampleData.Add(new SampleData()
                {
                    ID = Convert.ToInt16(data[0]),
                    FirstName = data[1].ToString(),
                    LastName = data[2].ToString(),
                    Email = data[3].ToString(),
                    Gender = data[4].ToString(),
                    IPAddress = data[5].ToString()
                });
            }

            _sampleData = _sampleData.OrderBy(o => o.ID).ToList();

            ultraDataSource1.Rows.SetCount(_sampleData.Count);
            ultraDataSource1.ResetCachedValues();

            UltraGridRow row = this.ultraGrid1.Rows.OfType<UltraGridRow>()
                .ToList().Find(r => r.Cells[0].Text.Equals(_activeId.ToString(), StringComparison.CurrentCultureIgnoreCase));

            ultraGrid1.ActiveRow = row;
            
            var activeIndex = ultraGrid1.ActiveRow.Index;

            ultraGrid1.ActiveRowScrollRegion.ScrollPosition = prevRow.VisibleIndex;
            ultraGrid1.Rows[activeIndex].Activate();
            ultraGrid1.Rows[activeIndex].Selected = true;
            ultraGrid1.ActiveRowScrollRegion.ScrollRowIntoView(row);

            button2.Enabled = true;

        }

        private void button2_Click(object sender, EventArgs e)
        {
            button2.Enabled = false;

            UltraGridRow prevRow = this.ultraGrid1.Rows.OfType<UltraGridRow>()
                .ToList()
                .Find(r => r.Cells[0].Text.Equals(_activeId.ToString(), StringComparison.CurrentCultureIgnoreCase));

            List<SampleData> items = _sampleData.Where(o => o.ID > 5 && o.ID < 11).ToList();

            foreach (SampleData sd in items)
            {
                _sampleData.Remove(sd);
            }

            ultraDataSource1.Rows.SetCount(_sampleData.Count);
            ultraDataSource1.ResetCachedValues();

            UltraGridRow row = this.ultraGrid1.Rows.OfType<UltraGridRow>()
                .ToList()
                .Find(r => r.Cells[0].Text.Equals(_activeId.ToString(), StringComparison.CurrentCultureIgnoreCase));

            ultraGrid1.ActiveRow = row;

            var activeIndex = ultraGrid1.ActiveRow.Index;

            ultraGrid1.ActiveRowScrollRegion.ScrollPosition = prevRow.VisibleIndex;
            ultraGrid1.Rows[activeIndex].Activate();
            ultraGrid1.Rows[activeIndex].Selected = true;

            ultraGrid1.ActiveRowScrollRegion.ScrollRowIntoView(row);
            button1.Enabled = true;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            // ------------------------------
            // these are used to make sure we only can select 1 row
            e.Layout.Override.SelectTypeRow = Infragistics.Win.UltraWinGrid.SelectType.Single;
            e.Layout.Override.RowSelectors = Infragistics.Win.DefaultableBoolean.True;
            e.Layout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.RowSelect;
            e.Layout.Override.SelectedAppearancesEnabled = Infragistics.Win.DefaultableBoolean.False;
            //e.Layout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.RowSelect;
            // -----------------------------------

            e.Layout.Override.HeaderClickAction = Infragistics.Win.UltraWinGrid.HeaderClickAction.SortSingle;

            // set the highlight of the row
            Infragistics.Win.Appearance activeRowAppearance = new Infragistics.Win.Appearance();
            activeRowAppearance.BackColor = System.Drawing.SystemColors.Highlight;
            activeRowAppearance.ForeColor = System.Drawing.SystemColors.HighlightText;
            this.ultraGrid1.DisplayLayout.Override.ActiveRowAppearance = activeRowAppearance;
        }

        private class SampleData
        {
            public Int16 ID { get; set; }
            public string FirstName { get; set; }
            public string LastName { get; set; }
            public string Email { get; set; }

            public string Gender { get; set; }

            public string IPAddress { get; set; }
        }

        private void ultraDataSource1_CellDataRequested(object sender, CellDataRequestedEventArgs e)
        {
            switch(e.Column.Key)
            {
                case "ID":
                    e.Data = this._sampleData[e.Row.Index].ID;
                    break;
                case "FirstName":
                    e.Data = this._sampleData[e.Row.Index].FirstName;
                    break;
                case "LastName":
                    e.Data = this._sampleData[e.Row.Index].LastName;
                    break;
                case "Email":
                    e.Data = this._sampleData[e.Row.Index].Email;
                    break;
                case "Gender":
                    e.Data = this._sampleData[e.Row.Index].Gender;
                    break;
                case "IPAddress":
                    e.Data = this._sampleData[e.Row.Index].IPAddress;
                    break;

            }
        }

        private void ultraGrid1_BeforeRowActivate(object sender, Infragistics.Win.UltraWinGrid.RowEventArgs e)
        {
            

        }

        private void ultraGrid1_AfterRowActivate(object sender, EventArgs e)
        {
            if (UltraGridRow.ReferenceEquals(ultraGrid1?.ActiveRow, null)) return;

            //_activeId = (Int16)ultraGrid1.ActiveRow.Cells[0].Value;

            //this.SelectedRow = ultraGrid1.ActiveRow;
        }

        private void ultraDataSource1_RowAdded(object sender, RowAddedEventArgs e)
        {
            //this.ultraGrid1.ActiveRow = this.ultraGrid1.Rows.GetRowWithListIndex(SelectedRow.Index);
            //this.ultraGrid1.ActiveRow.Selected = true;
        }

        private void ultraDataSource1_RowDeleted(object sender, RowDeletedEventArgs e)
        {
            //this.ultraGrid1.ActiveRow = this.ultraGrid1.Rows.GetRowWithListIndex(SelectedRow.Index);
            //this.ultraGrid1.ActiveRow.Selected = true;
        }

        private void ultraGrid1_MouseClick(object sender, MouseEventArgs e)
        {
            _activeId = (Int16)ultraGrid1.ActiveRow.Cells[0].Value;

            //this.SelectedRow = ultraGrid1.ActiveRow;
        }
    }
}
